#if !defined(__IMAGETEXTURE_H)
#define __IMAGETEXTURE_H

#include "Texture.h"

class ImageTexture : public Texture
{
public:

	ImageTexture();
	virtual ~ImageTexture();

	void configure(const string &prefix, const string &subKey);
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count);

	bool isTransparencyNeeded() { return transparencyNeeded; };
	bool isAlphaMapNeeded() { return (has_AlphaMap || has_hoverAlphaMap || has_pressedAlphaMap || has_animAlphaMap || has_hoveranimAlphaMap); };

private:

	bool UseAlphaMap;
	bool has_AlphaMap;
	bool has_hoverAlphaMap;
	bool has_pressedAlphaMap;
	bool has_animAlphaMap;
	bool has_hoveranimAlphaMap;
	void PrepareAlphaChannel(HBITMAP &bmp);

	void paintEffects(HDC destHDC, int width, int height, int imageType);

	bool useSmallIcon;

	int leftEdge;
	int topEdge;
	int rightEdge;
	int bottomEdge;

	int mode;

	int hoverleftEdge;
	int hovertopEdge;
	int hoverrightEdge;
	int hoverbottomEdge;

	int hovermode;

	int pressedleftEdge;
	int pressedtopEdge;
	int pressedrightEdge;
	int pressedbottomEdge;

	int pressedmode;

	int saturation;
	int hueIntensity;
	COLORREF hueColor;

	int hoversaturation;
	int hoverhueIntensity;
	COLORREF hoverhueColor;

	int pressedsaturation;
	int pressedhueIntensity;
	COLORREF pressedhueColor;

	int frameWidth;
	int frameHeight;
	int hoverframeWidth;
	int hoverframeHeight;

	HICON hIcon;

	HDC memoryAnimDC;
	HBITMAP memoryAnimBitmap;

	HDC memoryHoverAnimDC;
	HBITMAP memoryHoverAnimBitmap;

	HDC memoryDC;
	HBITMAP memoryBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryPressedDC;
	HBITMAP memoryPressedBitmap;

	int imageHeight;
	int imageWidth;

	int hoverimageHeight;
	int hoverimageWidth;

	int pressedimageHeight;
	int pressedimageWidth;

	bool transparencyNeeded;
};

#endif
