#if !defined(__LABELSETTINGS_H)
#define __LABELSETTINGS_H

class LabelSettings
{
private:

	bool isDefault;

public:

	LabelSettings();
	LabelSettings(const char *name, HWND box);
	virtual ~LabelSettings();

	bool alwaysOnTop;
	bool startHidden;
	bool bUseFahrenheit;

	Texture *skin;
	xFont *font;

	int leftBorder;
	int topBorder;
	int rightBorder;
	int bottomBorder;

	int align;
	int vertAlign;
	int updateInterval;
	bool alwaysUpdateContent;

	int width;
	int height;
	int x;
	int y;

	string borderMethod;

	int scrollInterval;
	int scrollSpeed;
	int scrollPadLength;
	int scroll;
	
	int autoWidthMode;
	int autoHeightMode;
	int autoMaxWidth;
	int autoMaxHeight;

	int transparencyMode;
	int alphaTransparency;
	bool alphaMap;
	bool alphaFade;
	string customalphaFade;
	bool ghosted;

	bool noTextSplit;
	string text;
	string hrefconfig;
	bool noEscape;
	string tooltip;
	bool balloontooltip;
	int tooltipmaxwidth;

	bool focusOnEnter;

	string snapTo;

	string leftClickCommand;
	string leftClickDownCommand;
	string leftDoubleClickCommand;
	string middleClickCommand;
	string middleClickDownCommand;
	string middleDoubleClickCommand;
	string rightClickCommand;
	string rightClickDownCommand;
	string rightDoubleClickCommand;
	string wheelDownCommand;
	string wheelUpCommand;
	string enterCommand;
	string leaveCommand;
	string dropCommand;
	string textChangeCommand;
	string resizeCommand;
	string moveCommand;

	string hideCommand;
	string showCommand;

    bool moveable;
	int moveKey;
	int moveButton;

	string labelGroup;

	string cursorPath;

	int overblendStyle;
};

extern LabelSettings* defaultSettings;

#endif
