
#if !defined(AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_)
#define AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_

#include "Texture.h"

class ShortcutTexture : public Texture
{
public:
	ShortcutTexture();
	virtual ~ShortcutTexture();

	void configure(const string &images, const string &useAlphaMap);
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return false; };

	bool isTransparencyNeeded() { return transparencyNeeded; };
	bool isAlphaMapNeeded() { return (has_AlphaMap || has_hoverAlphaMap || has_pressedAlphaMap); };

private:

	void PrepareAlphaChannel(HBITMAP &bmp);
	void checkMagicPink(HDC destHDC, int width, int height);

	bool has_AlphaMap;
	bool has_hoverAlphaMap;
	bool has_pressedAlphaMap;

	HDC memoryDC;
	HBITMAP memoryBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryPressedDC;
	HBITMAP memoryPressedBitmap;

	int imageHeight;
	int imageWidth;

	int hoverimageHeight;
	int hoverimageWidth;

	int pressedimageHeight;
	int pressedimageWidth;

	bool transparencyNeeded;
};

#endif // !defined(AFX_SHORTCUTTEXTURE_H__475A4EF6_04DF_4515_8972_CAD443513885__INCLUDED_)
