#if !defined(__SOLIDTEXTURE_H)
#define __SOLIDTEXTURE_H

#include "Texture.h"

typedef vector<COLORREF>::iterator ColorRefIterator;

class SolidTexture : public Texture
{
public:

	SolidTexture();
	virtual ~SolidTexture();

	void configure(const string &prefix, const string &subKey);
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return false; };

	bool isTransparencyNeeded() { return false; };
	bool isAlphaMapNeeded() { return false; };

private:

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseGradientCFG(string cfg, int imageType);
	void solidGradientPaint(HDC destHDC, vector<COLORREF> workGradient, RECT r, bool vertical);
	void solidPulsePaint(HDC destHDC, RECT r);

	int COLOR_STEP;
	int COLOR_DELAY;

	int bevelSize;
	int hoverbevelSize;
	int pressedbevelSize;

	bool verticalGradient;
	bool hoververticalGradient;
	bool pressedverticalGradient;

	string gradientColor;
	COLORREF backgroundColor;
	COLORREF darkBevelColor;
	COLORREF lightBevelColor;

	string hovergradientColor;
	COLORREF hoverbackgroundColor;
	COLORREF hoverdarkBevelColor;
	COLORREF hoverlightBevelColor;

	string pressedgradientColor;
	COLORREF pressedbackgroundColor;
	COLORREF presseddarkBevelColor;
	COLORREF pressedlightBevelColor;

	int CURRENT_NUM;
	
	COLORREF PULSE_COLOR[20];
	int NUM_COLORS;

	COLORREF HOVERPULSE_COLOR[20];
	int HOVERNUM_COLORS;

	vector<COLORREF> Gradient;
	vector<COLORREF> HoverGradient;
	vector<COLORREF> PressedGradient;

	int pulseCounter;
	double cr;
	double cg;
	double cb;
	double dr;
	double dg;
	double db;
};

#endif
